#!/bin/bash

name_reverse () {
    local ret

    while [ $# -gt 0 ] ; do
        ret="${1}.${ret}"
        shift
    done

    echo "${ret}" | sed 's/.$//'
}

while read address others; do
    oldifs="${IFS}"
    IFS="."
    reversed=$(name_reverse ${address})
    IFS="${oldifs}"
    echo "${reversed} ${others}"
done
