#!/bin/bash
#
# ե뺹ʬХååץץ
#
# usage:
# 1. BACKUP_ROOT(/var/tmp/backup) ˡХååפȤꤿեؤ
#    ܥå󥯤ĥޤ
#    : cd ${BACKUP_ROOT}; ln -s /etc/nsswitch.conf
# 2. backup_etc.bash ʤǼ¹Ԥޤ

# Хåå׺ѥǥ쥯ȥ
BACKUP_ROOT="/var/tmp/backup"

# Хåå׺ѥǥ쥯ȥκο
MAX_DEPTH=2

# RCS Υåå(/֤ʤ)
CHECKIN_MSG="Automatic_RCS_backup"

# ˱ơ
#   ֥ǥ쥯ȥο + 1
# ɽ glob ѥ
# usage: make_pattern <depth>
# ex. make_pattern 1  "*/*"
make_pattern () {
    local -i i=$1
    local pattern="*"

    while [ $i -gt 0 ]; do
        pattern="${pattern}/*"
        let "i--"
    done

    echo "${pattern}"
}

# RCS  ci (å)ޥɤȤäƺʬХååפȤޤ
# : ʤ
make_rcs_backup () {
    local dir
    local pattern=$(make_pattern ${MAX_DEPTH})
    local lock_user
    local file
    local msg

    # CHECKIN_MSG ꤵƤ
    # msg ѿƤ -m"å" Ȥޤ
    msg=${CHECKIN_MSG:+"-m${CHECKIN_MSG}"}

    # BACKUP_ROOT ˰ư
    pushd "${BACKUP_ROOT}" > /dev/null

    # RCS Ȥ̾ʳΥǥ쥯ȥõ
    # BSDƥǤ find -x . -type d ... Ȥ뤳
    find . -xdev -type d \( -name RCS -prune -o -print \) | \
        while read dir; do
            case "${dir}" in
                ${pattern})
                    # MAX_DEPTH ۤΤоݳ
                    continue
                    ;;
            esac

	    # оݥǥ쥯ȥ˰ư
            cd "${BACKUP_ROOT}/${dir}"
	    if [ ! -d RCS ]; then
		mkdir RCS
            fi

	    # ե뤴Ȥ ci ¹
            for file in *; do
		if [ -d "${file}" ]; then
		    continue
		fi

		ci ${msg} -l "${file}" < /dev/null > /dev/null 2>&1
		if [ $? -ne 0 ]; then
		    echo "backup FAIL: ${file}" 1>&2
		fi
	    done
        done            

    # ǽ餤ǥ쥯ȥ
    popd > /dev/null
}

make_rcs_backup
