#!/bin/bash
#
# ץ¸ƻ륹ץ
#
# usage: check_proc_alive.bash

# ƻоݤ򵭽Ҥե
PROGLIST=/usr/local/etc/check_progs.conf

# util_common.bash(ucb_ps) ɤ߹
# 1. PATH ̤äƤȤɤ߹
# 2. ΥץȤǥ쥯ȥդǼ¹ԤƤС
#    ΥץȤƱ꤫ɤ߹
# 3. 1., 2. ǥʤ饨顼
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ꤵ줿ץΥץ ID 
#
# Ȥ
#   pidof [-s] <prog_name>
#
# :
#   -s
#     ĤǤץĤä顢ǽ򽪤
#   prog_name
#     õץ̾
#
# 
#   ץID_1 ץID_2  ...
#   (ץĤʤ϶Ԥ 1 ԽϤ)
#
# λơ:
#   0: ץĤä
#   1: ץ¸ߤʤä
pidof () {
    local cmd_target            # õޥ
    local is_single             # -s ץ󤬻ꤵ줿

    # ν
    is_single=false

    case "$1" in
      -s)
        is_single=true
	shift
	;;
    esac

    cmd_target="$1"

    # ʲΥޥ(ѥץ饤)ͤؿͤˤʤ
    ucb_ps ax | (
	# 饵֥ʤΤǡѿϸƤӽФˤ
	# ƶޤ󡣤ä local ⤢ޤ
	# ѿνɬפǤ
	pids=""

	# إåԤϼΤƤޤ
	read line

	# 2 ܰʹߤν
	while read pid tty stat time cmd args; do
	    # оݹԤΤǤ뤫
	    was_found="false"

	    if [ "${cmd}" = "${cmd_target}" ]; then
		# Τޤް
		was_found="true"
	    elif [ "${cmd##*/}" = "${cmd_target}" ]; then
		# ١̾
		was_found="true"
	    fi

	    if ${was_found} ; then
		pids="${pids} ${pid}"
		if ${is_single}; then
		    # -s ꤵƤФǽꡣ
		    # λơ 0
		    break
		fi
	    fi
	done

	# ̤ɽ
	echo ${pids}

	# λơ
	[ "${pids}" != "" ]
    )
}

# ץ¸ƻ
# ʤ
check_alive_procs () {
    # PROGLIST ¸ߥå
    if [ ! -r "${PROGLIST}" ]; then
	echo "Can't read ${PROGLIST}"
	return 1
    fi

    # PROGLIST ιԤȤΥ롼
    cat "${PROGLIST}" | while read prog ; do
	case "${prog}" in
	    "")   continue ;;
	    "#"*) continue ;;
	esac
	pids=$(pidof ${prog})
	if [ $? -ne 0 ]; then
	    pids="DOWN"
	fi
	echo "${prog}: ${pids}"
    done
}

check_alive_procs
