# դϤ򤵤ؿ
# 
#   $1: ǥեȥ
#   $2: 
#        [ { "sdate" | "edate" } ǯ   ]
#       оݤƬ/ǯ(ǥեȥפ5Τ)
# 
#   (Ϥν񼰤Ʊ)
# Ϥ tty ʳξưʤ
query_date_query () {
    local date_type="$1"
    local sdate
    local edate
    local tty
    local line
    local ret_str

    # ɸϥå
    tty=$(tty) 2> /dev/null 2>&1
    if [ $? -ne 0 ]; then
	return 1
    fi

    # ɸϤѹ(ߤνfd 3¸)
    exec 3>&1 1>${tty}

    # ν
    shift
    while [ $# -ge 4 ]; do
        case "$1" in
	  sdate)
	    sdate="$2 $3 $4"
	    shift 4
	    ;;
	  edate)
	    edate="$2 $3 $4"
	    shift 4
	    ;;
	  *)
	    break
	    ;;
	esac
    done

    # פ򤵤ޤ̵¥롼
    while :; do
	# ɽ
	query_date_print "${date_type}" "${sdate}" "${edate}"

	# (1ʸ)
	read -n 1 -p '(0: )> ' line
	if [ $? -ne 0 ]; then
	    break
	fi

	case "${line}" in
	  0 | $'003')
	    # ]
	    #  Ctrl-C
	    break
	    ;;
          [1-4])
            date_type="${line}"
	    ;;
	  5)
	    #ջ
	    # 
	    echo
	    ret_str=$(query_date_range)
	    if [ $? -eq 0 ]; then
		eval "${ret_str}"
		date_type=5
	    fi
	    ;;
          "")
	    # ꥿Τߤϲ⤷ʤ
	    ;;
          *)
	    # ä
	    echo 'Ϥ˸꤬ޤ' 1>&2
	    echo '򲡤Ƥ'
	    read -n 1 line
	    ;;
	  esac

    done

    # ɸϤ򸵤᤹(fd3Ĥ)
    exec 1>&3 3>&-

    # ̤
    printf ${date_type}
    [ "${sdate}" != "" ] && printf " sdate %s" "${sdate}"
    [ "${edate}" != "" ] && printf " edate %s" "${edate}"
    return 0
}

# 桼ؤ碌ʸɸϤɽ
# 
#   $1: 򤵤줿
#   $2: Ƭ(פ 5 ξΤ/ڤ)
#   $3: (פ 5 ξΤ/ڤ)
query_date_print () {
    local -a mark
    local sdate
    local edate

    # ɽޡ
    mark=([1]=' ' [2]=' ' [3]=' ' [4]=' ' [5]=' ')
    mark[$1]="*"

    # ϰϤɽʸ
    sdate="$2"
    edate="$3"
    if [ "$2" != "" ]; then
	sdate=$(printf "%04d/%02d/%02d" $2)
    fi
    if [ "$3" != "" ]; then
	edate=$(printf "%04d/%02d/%02d" $3)
    fi

    # ̥ꥢ
    clear
    cat <<EOF
ѹޤ?
${mark[1]}1) $(query_date_string 1)
${mark[2]}2) $(query_date_string 2)
${mark[3]}3) $(query_date_string 3)
${mark[4]}4) $(query_date_string 4)
${mark[5]}5) $(query_date_string 5 "${sdate}" "${edate}")

(ꤵƤΤˤ * դƤޤ)

EOF
}

# ""б碌ʸ֤
query_date_string () {
    case "$1" in
      1) echo '狼ʤ' ;;
      2) echo '1ְ'  ;;
      3) echo '1'  ;;
      4) echo '1ǯ'    ;;
      5)
         printf "ջ(%s  %s)" "${2:----}" "${3:----}"
	 ;;
    esac
}

# դϰϤϤؿ
# 
#   ʲ(ʣԤ)ʸevalλѤꤷƤ롣
#     sdate="<Ƭ>"
#     edate="<>"
query_date_range () {
    local line
    local sdate
    local edate

    while :; do
	read -p 'Ƭ(:YYYY/MM/DD, 0:)> ' line
	case "${line}" in
	  "")
	    sdate=""
	    ;;
          0)
	    return 1
	    ;;
          *)
	    sdate=$(validate_date "${line}")
	    if [ $? -ne 0 ]; then
		echo '񼰤ְäƤޤ' 1>&2
		continue
	    fi
	    ;;
	esac
	break
    done

    while :; do
	read -p '(:YYYY/MM/DD, 0:)> ' line
	case "${line}" in
	  "")
	    edate=""
	    ;;
          0)
	    return 1
	    ;;
          *)
	    edate=$(validate_date "${line}")
	    if [ $? -ne 0 ]; then
		echo '񼰤ְäƤޤ' 1>&2
		continue
	    fi
	    ;;
	esac
	break
    done

    if [ "${sdate}${edate}" == "" ]; then
	echo 'ɤ餫դϤƤ' 1>&2
	query_date_range
	return
    fi

    # ̤ν
    cat <<-EOF
	sdate="${sdate}"
	edate="${edate}"
	EOF
}

# ʸåؿ
# ʸ󤬰ʲν񼰤Ǥ뤫ɤå
#   ǯ  
# ȤʸϤ롣줾ͤ0Ԥʤ
#
# դեޥå:
#      Y/M/D
#     YY/M/D (YY < 70 ʤ2000ǯ, Ǥʤ1900ǯ)
#   YYYY/M/D
#   (M,D  1 ޤ 2 ο)
# λơ:
#   0    : ʸȤ
#   1ʾ: ʸȤʤ
validate_date () {
    local status
    local y
    local m
    local d
    local end_of_m

    # (1-4)/(2)/(2) ɤ
    echo "$1" | grep -q '^[0-9]\{1,4\}/[0-9]\{1,2\}/[0-9]\{1,2\}$'
    [ $? -eq 0 ] || return 1

    # ǯ//ʬ
    y=${1%%/*}
    m=$(echo "$1" | sed 's:.*/\([^/]*\)/.*:\1:')
    d=${1##*/}

    # ǯΥå2ɽξ
    case "${y}" in
      ?)
        y="200${y}"
        ;;
      [0-6]?)
        y="20${y}"
	;;
      [7-9]?)
        y="19${y}"
	;;
      0* | 1[0-8]* | 19[0-6]* | ???)
        return 1
        ;;
    esac

    # Υå
    case "${m}" in
      [1-9])
        ;;
      0[1-9])
        m="${m:1}"
        ;;
      1[012])
        ;;
      *)
	return 1
        ;;
    esac

    # Υå
    case "${d}" in
      0)
        return 1
	;;
      [1-9])
        ;;
      0[1-9])
        d="${d:1}"
	;;
      *)
	end_of_m=$(days_of_month "${y}" "${m}")
	if [ "${d}" -gt "${end_of_m}" ]; then
	    return 1
	fi
    esac

    echo "${y} ${m} ${d}"
}

# ׻ؿ
# :
#   $1: ǯ
#   $2: (Ƭ0դʤ)
# :
#   
days_of_month () {
    case "$2" in
      4|6|9|11)
        echo 30
	;;
      2)
	is_not_leap "$1"
	echo $((28 + $?))
	;;
      *)
	echo 31
	;;
    esac
}

# ǯȽؿ
# (letʸͤʤΤ)
#   0: ̤ǯ
#   1: ǯ
is_not_leap () {
    local -i y="$1"
    let "(y % 4) ? 1 : ((y % 400) ? (y % 100 == 0) : 0)"
}
