#!/bin/bash
#
# FTPˤե

################################################
# 
################################################
# ե
L_FILE="եեѥ"
# ۥ
R_HOST="ΥС̾.netrcϿƤΡ"
# ǥ쥯ȥ
R_DIR="ΥСΥǥ쥯ȥ"

################################################
# ؿ
################################################
# ե FTP 
# 
#   $1: ե̾
#   $2: ۥ̾
#   $3: ǥ쥯ȥ
#   $4: ȥǥ쥯ȥ
# λơ
#   0: 
#   1: 
ftp_put_file () {
    local l_file="$1"
    local r_host="$2"
    local r_dir="$3"
    local tmpdir="$4"

    local filename="${l_file##*/}"
    local r_file="${r_dir}/${filename}"
    local log="${tmpdir}/ftp_put.log"

    local status

    # FTP ¹
    ftp -v -g "${r_host}" <<-EOF > "${log}" 2>&1
	quote NOOP
	put "${l_file}" "${r_file}"
	quote NOOP
	EOF

    # ̥å(1)
    status=$?
    if [ "${status}" -ne 0 ]; then
	return "${status}"
    fi

    # ̥å(2)
    ftp_chk_transfer "${log}"

    # Ԥˤϥ顼å(⤷ʤ)
    # κǸ3Ԥɸ२顼Ϥɽ
    if [ $? -ne 0 ]; then
	grep -v '^[123][0-9][0-9]' "${log}" | tail -3 1>&2
	return 1
    fi

    return 0
}

# FTP ˤե򡢥å
# 
#   $1: ž
# λơ
#   0: ž
#   1: ž
ftp_chk_transfer () {
    local state="START"
    local code
    local msg_first
    local msg_rest

    # եɤߤʤΥ롼
    while read code msg_first msg_rest; do
	case "${state}" in
	# ǽ NOOP ¹
	START)
	    if [ "${code} ${msg_first}" == "200 NOOP" ]; then
		state=TRANS_START
	    fi
	    ;;
        # PASV/PORT ǤΥͥΩ
	TRANS_START)
	    case "${code}" in
	    125 | 150)
		state=TRANS_DATA
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	# ǡž
	TRANS_DATA)
	    case "${code}" in
	    226 | 250)
		# ž
		state=SUCCESS
		break
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	esac
    done < "$1"

    # ʲ test η̤ؿνλơ
    [ "${state}" == "SUCCESS" ]
    return
}

################################################
# ᥤ
################################################
# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

ftp_put_file \
    "${L_FILE}" \
    "${R_HOST}" \
    "${R_DIR}" \
    "${tmpdir}"

status=$?

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}

# ץȤνλơ
#  ftp_put_file νλơ
exit ${status}
