#
# ̴ؿ(sh )
#

# BSD  ps ޥ
# : ps ޥɤΰƱ
ucb_ps () {
    CMD_PS=/usr/ucb/ps

    if [ ! -x ${CMD_PS} ]; then
	CMD_PS=ps
    fi

    ${CMD_PS} "$@"
}

# ()ǥե(POSIX)ˤ
# : ʤ
unset_linguas () {
    LC_ALL=C
    LC_MESSAGES=C
    LANGUAGE=C
    LANG=C
    export LC_ALL
    export LC_MESSAGES
    export LANGUAGE
    export LANG
}

# ǥ쥯ȥκ
# : ǥ쥯ȥοƥǥ쥯ȥ
#       (άǥե: ${TMP_ROOT})
# : ǥ쥯ȥ̾
# λơ: 0: , 1: 
# ѿ:
#   TMP_ROOT(IN): ǥ쥯ȥοƥǥ쥯ȥ
#                 (άǥե: ${HOME})
make_tmp_dir () {
    # ǥ쥯ȥοƥǥ쥯ȥ
    TMP_ROOT="${1:-${TMP_ROOT:-${HOME}}}"
    tmpdir=`basename "$0"`$$

    tmpdir="${TMP_ROOT}/${tmpdir}"
    mkdir "${tmpdir}" > /dev/null 2>&1
    if [ $? -eq 0 ] ; then
	echo "${tmpdir}"
    else
	echo "Can't create directory: ${tmpdir}" 1>&2
	return 1
    fi
}

# ǥ쥯ȥκ
# : ǥ쥯ȥοƥǥ쥯ȥ
#       (άǥե: ${TMP_ROOT})
# : ʤ
# λơ: 0: , 1ʾ: 
#   TMP_ROOT(IN): ǥ쥯ȥοƥǥ쥯ȥ
#                 (άǥե: ${HOME})
clean_tmp_dir () {
    # ǥ쥯ȥοƥǥ쥯ȥ
    TMP_ROOT="${1:-${TMP_ROOT:-${HOME}}}"
    tmpdir=`basename "$0"`$$

    tmpdir="${TMP_ROOT}/${tmpdir}"

    # ǥ쥯ȥ꤬¸ߤʤХ顼ˤޤ
    if [ ! -d "${tmpdir}" ]; then
	echo "No such directory: ${tmpdir}" 1>&2
	return 1
    fi
    # оݤܥåξϡ곰Τᥨ顼ˤޤ
    if [ -L "${tmpdir}" ]; then
	echo "Can't delete unexpected symlink: ${tmpdir}" 1>&2
	return 1
    fi
    # rm ޥɤνλơ򤽤Τޤ֤ޤ
    rm -rf "${tmpdir}" > /dev/null 2>&1
}
