#!/bin/bash

########################################################
# 
########################################################
# ѥɥե(桼)
AUTH_USER_FILE="/etc/httpd/passwd"

########################################################
# ؿ
########################################################
# YES/NO Ҥͤؿ
# 
#   $1: ʸ
# 
#   "YES" ޤ "NO"
query_yes_no () {
    local query="$1"
    local var
    local ret

    while [ "${ret}" == "" ]; do
	echo "${query}" 1>&2
	select var in yes no; do
	    case "${var}" in
		yes)
		    ret="YES"
		    ;;
		no)
		    ret="NO"
		    ;;
	    esac

	    break
	done
    done

    echo "${ret}"
}

########################################################
# ᥤ
########################################################
#### SSL ׵᤹뤫ɤ
ans=$(query_yes_no "Request SSL?")
if [ "${ans}" == "YES" ]; then
    echo SSLRequireSSL
fi

#### ǧڲ̤Υȥ
ans=""
while [ "${ans}" != "YES" ]; do
    read -p "Please input Authentication Name(in English)> " line
    ans=$(query_yes_no "Is it OK?: ${line}")
done

echo "AuthName \"${line}\""

#### 桼DB
ans=""
while [ "${ans}" != "YES" ] ; do
    echo "Input user password file(default: ${AUTH_USER_FILE})" 1>&2
    read -p "> " line

    # ϤʤǥեȤѤ
    if [ "${line}" == "" ]; then
	line="${AUTH_USER_FILE}"
    fi

    # ե뤬¸ߤ뤫ɤå
    if [ ! -f "${line}" ]; then
	echo "No such File: ${line}" 1>&2
	continue
    fi

    ans=$(query_yes_no "Is it OK?: ${line}")
done

echo "AuthUserFile ${line}"

# AUTH_USER_FILE ͤ¾ǤѤƤΤǡ
AUTH_USER_FILE="${line}"

#### Ĥ桼
ans=""
while [ "${ans}" != "YES" ]; do
    echo "Input valid user(s)(\"valid-user\" = all authenticated users)" 1>&2
    read -p "> " line

    # 桼¸ߤ뤫å
    for user in ${line}; do
	if [ "${user}" == "valid-user" ]; then
	    # valid-user äˤϡ¾̵
	    line="valid-user"
	    break
	fi

	grep -q "^${user}" "${AUTH_USER_FILE}" > /dev/null 2>&1
	if [ $? -ne 0 ]; then
	    echo "WARNING!: No such user: ${user}" 1>&2
	fi
    done

    ans=$(query_yes_no "Is it OK?: ${line}")
done

# Require ν񼰤
#   Require valid-user
#   Require user 桼̾ ...
# ʤΤǡԤξ line ͤ
if [ "${line}" != "valid-user" ]; then
    line="user ${line}"
fi

echo "Require ${line}"
