# ʸåؿ
# ʸ󤬰ʲν񼰤Ǥ뤫ɤå
#   ǯ  
# ȤʸϤ롣줾ͤ0Ԥʤ
#
# դեޥå:
#      Y/M/D
#     YY/M/D (YY < 70 ʤ2000ǯ, Ǥʤ1900ǯ)
#   YYYY/M/D
#   (M,D  1 ޤ 2 ο)
# λơ:
#   0    : ʸȤ
#   1ʾ: ʸȤʤ
validate_date () {
    local status
    local y
    local m
    local d
    local end_of_m

    # (2-4)/(2)/(2) ɤ
    echo "$1" | grep -q '^[0-9]\{1,4\}/[0-9]\{1,2\}/[0-9]\{1,2\}$'
    [ $? -eq 0 ] || return 1

    # ǯ//ʬ
    y=${1%%/*}
    m=$(echo "$1" | sed 's:.*/\([^/]*\)/.*:\1:')
    d=${1##*/}

    # ǯΥå2ɽξ
    case "${y}" in
      ?)
        y="200${y}"
        ;;
      [0-6]?)
        y="20${y}"
	;;
      [7-9]?)
        y="19${y}"
	;;
      0* | 1[0-8]* | 19[0-6]* | ???)
        return 1
        ;;
    esac

    # Υå
    case "${m}" in
      [1-9])
        ;;
      0[1-9])
        m="${m:1}"
        ;;
      1[012])
        ;;
      *)
	return 1
        ;;
    esac

    # Υå
    case "${d}" in
      0)
        return 1
	;;
      [1-9])
        ;;
      0[1-9])
        d="${d:1}"
	;;
      *)
	end_of_m=$(days_of_month "${y}" "${m}")
	if [ "${d}" -gt "${end_of_m}" ]; then
	    return 1
	fi
    esac

    echo "${y} ${m} ${d}"
}

# ǯȽؿ
# (letʸͤʤΤ)
#   0: ǯ
#   1: ̤ǯ
is_leap () {
    local -i y="$1"
    let "(y % 4) ? 0 : ((y % 400) ? (y % 100) : 1)"
}

# ǯȴؿ
# 
#  $1: ǯ
# 
#   ǯβ
num_leaps () {
    local y="$1"
    echo $((y / 4 - y / 100 + y / 400))
}

# ׻ؿ
# :
#   $1: ǯ
#   $2: (Ƭ0դʤ)
# :
#   
days_of_month () {
    case "$2" in
      4|6|9|11)
        echo 30
	;;
      2)
	if is_leap "$1"; then
	    echo 29
        else
	    echo 28
        fi
	;;
      *)
	echo 31
	;;
    esac
}

# ǯ̻׻ؿ
# :
#   $1: ǯ(Ƭ0դʤ)
#   $2: (Ƭ0դʤ)
#   $3: (Ƭ0դʤ)
# :
#   ̻
day_of_year () {
    local -i y="$1"
    local -i m="$2"
    local -i d="$3"
    local -i leap

    if is_leap "${y}"; then
	leap=1
    else
	leap=0
    fi

    case "${m}" in
      1)  echo "$d"	           ;;
      2)  echo $((d +  31))        ;; 
      3)  echo $((d +  59 + leap)) ;;
      4)  echo $((d +  90 + leap)) ;;
      5)  echo $((d + 120 + leap)) ;;
      6)  echo $((d + 151 + leap)) ;;
      7)  echo $((d + 181 + leap)) ;;
      8)  echo $((d + 212 + leap)) ;;
      9)  echo $((d + 243 + leap)) ;;
      10) echo $((d + 273 + leap)) ;;
      11) echo $((d + 304 + leap)) ;;
      12) echo $((d + 334 + leap)) ;;
    esac
}
    
# դΰ򤹤ؿ
# (줾ͤƬ0դʤ)
#   $1:  ǯ
#   $2:  
#   $3:  
#   $4:  ǯ
#   $5:  
#   $6:  
# 
#   
sub_date () {
    local -i y1="$1"
    local -i d1=$(day_of_year "$1" "$2" "$3")
    local -i leaps1=$(num_leaps $((y1 - 1)))

    local -i y2="$4"
    local -i d2=$(day_of_year "$4" "$5" "$6")
    local -i leaps2=$(num_leaps $((y2 - 1)))

    echo $(((y1 - y2) * 365 + leaps1 - leaps2 + d1 - d2))
}
