#!/bin/bash
#
# FTPˤե

################################################
# 
################################################
# ե
R_FILE="СΥե̾ȥåפΥѥǻ"
# ۥ
R_HOST=".netrcϿƤ륵С̾"
# ǥ쥯ȥ
L_DIR="ɤƤǥ쥯ȥ"

################################################
# ؿ
################################################
# ե FTP Ǽ
# 
#   $1: ե̾
#   $2: ۥ̾
#   $3: ǥ쥯ȥ
#   $4: ȥǥ쥯ȥ
# λơ
#   0: 
#   1: 
ftp_get_file () {
    local r_file="$1"
    local r_host="$2"
    local l_dir="$3"
    local tmpdir="$4"

    local filename="${r_file##*/}"
    local l_file="${l_dir}/${filename}"
    local log="${tmpdir}/ftp_get.log"

    local status

    # FTP ¹
    ftp -v -g "${r_host}" <<-EOF > "${log}" 2>&1
	quote NOOP
	get "${r_file}" "${l_file}"
	quote NOOP
	EOF

    # ̥å(1)
    status=$?
    if [ "${status}" -ne 0 ]; then
	return "${status}"
    fi

    # ̥å(2)
    ftp_chk_transfer "${log}"

    # Ԥˤϥ顼å(⤷ʤ)
    # κǸ3Ԥɸ२顼Ϥɽ
    if [ $? -ne 0 ]; then
	grep -v '^[123][0-9][0-9]' "${log}" | tail -3 1>&2
	return 1
    fi

    return 0
}

# FTP ˤե򡢥å
# 
#   $1: ž
# λơ
#   0: ž
#   1: ž
ftp_chk_transfer () {
    local state="START"
    local code
    local msg_first
    local msg_rest

    # եɤߤʤΥ롼
    while read code msg_first msg_rest; do
	case "${state}" in
	# ǽ NOOP ¹
	START)
	    if [ "${code} ${msg_first}" == "200 NOOP" ]; then
		state=TRANS_START
	    fi
	    ;;
        # PASV/PORT ǤΥͥΩ
	TRANS_START)
	    case "${code}" in
	    125 | 150)
		state=TRANS_DATA
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	# ǡž
	TRANS_DATA)
	    case "${code}" in
	    226 | 250)
		# ž
		state=SUCCESS
		break
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	esac
    done < "$1"

    # ʲ test η̤ؿνλơ
    [ "${state}" == "SUCCESS" ]
    return
}

# ե
# 
#   $1: ե̾
#   $2: ۥ̾
#   $3: ȥǥ쥯ȥ
# 
#   YYYYMMDDhhmm.ssν(GMT)
# λơ
#   0: 
#   1: 
ftp_get_mdtm () {
    local r_file="$1"
    local r_host="$2"
    local tmpdir="$3"
    local log="${tmpdir}/ftp_mdtm.log"

    local status
    local mdtm

    # FTP ¹
    ftp -v -g "${r_host}" <<-EOF > "${log}" 2>&1
	quote NOOP
	quote MDTM "${r_file}"
	quote NOOP
	EOF

    # ̥å(1)
    status=$?
    if [ "${status}" -ne 0 ]; then
	return "${status}"
    fi

    # 
    mdtm=$(ftp_chk_mdtm "${log}")
    if [ $? -ne 0 ]; then
	return 1
    fi

    # ߥðʲơä . ɲ
    mdtm="${mdtm%.*}"
    mdtm="${mdtm:0:12}.${mdtm:12}"
    echo "${mdtm}"
}

# ե뽤FTPΥե뤫Ф
# 
#   $1: FTP
# 
#   YYYYMMDDHHMMSS[.sss]λ(GMT)
# λơ
#   0: 
#   1: 
ftp_chk_mdtm () {
    local state="START"
    local code
    local msg_first
    local msg_rest

    # եɤߤʤΥ롼
    while read code msg_first msg_rest; do
	case "${state}" in
	# ǽ NOOP ¹
	START)
	    if [ "${code} ${msg_first}" == "200 NOOP" ]; then
		state=MDTM_START
	    fi
	    ;;
        # MDTM¹
	MDTM_START)
	    case "${code}" in
	    213)
		state=SUCCESS
		break;
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	esac
    done < "$1"

    # ̤ SUCCESS ǤʤХ顼
    if [ "${state}" != "SUCCESS" ]; then
	return 1
    fi

    # ̤ν(YYYYMMDDHHMMSS[.sss])
    echo "${msg_first}" | egrep -q '^[0-9]{14}(\.[0-9]{1,3})?$'
    if [ $? -ne 0 ]; then
	return 1
    fi

    # 񼰤ɸϤɽ
    echo "${msg_first}"
}

################################################
# ᥤ
################################################
# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

ftp_get_file \
    "${R_FILE}" \
    "${R_HOST}" \
    "${L_DIR}" \
    "${tmpdir}"

status=$?

# ¹Ԥ顢եλν
# (､Υ顼̵)
if [ "${status}" -eq 0 ]; then
    MDTM=$(ftp_get_mdtm "${R_FILE}" "${R_HOST}" "${tmpdir}")
    if [ $? -eq 0 ]; then
	L_FILE="${L_DIR}/${R_FILE##*/}"
	# MDTM ͤ GMT(ΤϤ)
	TZ=GMT touch -t "${MDTM}" "${L_FILE}" > /dev/null 2>&1
    fi
fi

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}

# ץȤνλơ
#  ftp_put_file νλơ
exit ${status}
