#!/bin/bash
#
# FTPˤեꥹȤμ

################################################
# 
################################################
# оݥǥ쥯ȥ
R_DIR="СΥǥ쥯ȥ"
# ³ۥ
R_HOST=".netrcϿС̾"

################################################
# ؿ
################################################
# եꥹȤ
# 
#   $1: оݥǥ쥯ȥ
#   $2: ۥ̾
#   $3: ȥǥ쥯ȥ
# λơ
#   0: 
#   1: 
ftp_ls_dir () {
    local r_dir="$1"
    local r_host="$2"
    local tmpdir="$3"

    local l_file="${tmpdir}/ftp_ls.out"
    local log="${tmpdir}/ftp_ls.log"

    local status

    # FTP ¹
    ftp -v -g "${r_host}" <<-EOF > "${log}" 2>&1
	prompt
	quote NOOP
	cd "${r_dir}"
	quote NOOP
	ls -l "${l_file}"
	quote NOOP
	EOF

    # ̥å(1)
    status=$?
    if [ "${status}" -ne 0 ]; then
	return "${status}"
    fi

    # ̥å(2)
    ftp_chk_ls "${log}"

    # Ԥˤϥ顼å(⤷ʤ)
    # κǸ3Ԥɸ२顼Ϥɽ
    if [ $? -ne 0 ]; then
	grep -v '^[123][0-9][0-9]' "${log}" | tail -3 1>&2
	return 1
    fi

    cat "${l_file}"
    return 0
}

# FTP ˤեꥹȼ򡢥å
# 
#   $1: ž
# λơ
#   0: ž
#   1: ž
ftp_chk_ls () {
    local state="START"
    local code
    local msg_first
    local msg_rest

    # եɤߤʤΥ롼
    while read code msg_first msg_rest; do
	case "${state}" in
	# ǽ NOOP ¹
	START)
	    if [ "${code} ${msg_first}" == "200 NOOP" ]; then
		state=CWD_START
	    fi
	    ;;
	# CWD ޥɼ¹
	CWD_START)
	    case "${code}" in
	    250)
		state=CWD_OK
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	# CWD ¹Ը
	CWD_OK)
	    if [ "${code}" == "200" ]; then
		state="TRANS_START"
	    fi
	    ;;
        # PASV/PORT ǤΥͥΩ
	TRANS_START)
	    case "${code}" in
	    125 | 150)
		state=TRANS_DATA
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	# ǡž
	TRANS_DATA)
	    case "${code}" in
	    226 | 250)
		# ž
		state=SUCCESS
		break
		;;
	    200)
		if [ "${msg_first}" == NOOP ]; then
		    # 곰
		    state="ERROR"
		    break
		fi
		;;
	    esac
	    ;;
	esac
    done < "$1"

    # ʲ test η̤ؿνλơ
    [ "${state}" == "SUCCESS" ]
    return
}

################################################
# ᥤ
################################################
# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

ftp_ls_dir \
    "${R_DIR}" \
    "${R_HOST}" \
    "${tmpdir}"

status=$?

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}

# ץȤνλơ
#  ftp_ls_dir νλơ
exit ${status}
